﻿//IPRINT.CS iprogram author nobumich harasawa
using System;
using System.Collections;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Printing;
using System.IO;
using System.Text;
using System.Timers;
using System.Windows.Forms;

public class form_l:Form
{
//=====================================================================
//************************( wndproc )**********************************
//=====================================================================
string[] help_sx={
#if UNIX
"IPRINTU.EXE {REAL,TEST,TEST_DATA} データ レイアウト 開始 終了",
#else
#if FRAMEWORK4
"IPRINTW4.EXE {REAL,TEST,TEST_DATA} データ レイアウト 開始 終了",
#else
#if MONO
"IPRINTWM.EXE {REAL,TEST,TEST_DATA} データ レイアウト 開始 終了",
#else
"IPRINTW.EXE {REAL,TEST,TEST_DATA} データ レイアウト 開始 終了",
#endif
#endif
#endif
"文字，罫線，バーコード(code39,jan)を紙に印刷するためのプログラムです。",
"◎'TEST'の時は印刷情報を画面に表示します。",
"◎'TEST_DATA'の時はデータを読まないで自動的に作り出します。",
"　マウス右ボタンのPrintで１頁分のテスト印刷をします。",
"　Enterキーで次のページを表示し，Escキーで終了します。",
"　→,←,↑,↓,で画面内を移動し,Inset,Delete,Home,Endで拡大縮小します。",
"　線幅が異なっても解像度の問題で画面で幅が変わって見えない時は拡大して下さい。",
"◎'REAL'の時は実際に印刷します。",
"◎データが空の時は'IPRINT.TXT'と見なします。",
"　データでそれぞれの印刷データをタブで区切って指定します。",
"　１ページ分のデータの終わりがレコードの切れ目と合わない場合エラーになります。",
"◎レイアウトが空の時は'IPRINT.CSV'と見なします。",
"　レイアウトで印刷レイアウトをＣＳＶ形式で指定します。",
"　先頭に'*'の有るレコードは注釈とみなします。",
"　最後に'\\'の有るレコードは継続します。",
"　文字列が空の時はデータより文字列を読み込みます。",
"　ｘは右方向，ｙは下方向のオフセットの位置を表します。",
"　位置，高，幅は１ｍｍ単位で指定し小数点以下も指定できます。",
"　線種は以下の指定ができます。",
"　（０＝実線，１＝破線、２＝点線、３＝１点破線、４＝２点破線）",
"　数値項目を省略した場合は０と見なします。",
"　くり返し項目が０のときは以降くり返し無しと見なします。",
"●用紙を指定 PAPER,用紙サイズ,印刷の向き",
"             用紙サイズはA4,B5等プリンタで指定可能な物です,空は既定値です。",
"             印刷の向きは１が縦向きで、２が横向きです、空は既定値です。",
"●オフセット情報を指定 OFFSET,x,y[,x以降くり返し]。",
"●線名を指定    LINE_SET,線名,線幅,線種,線名以降くり返し",
"●文字名を指定  CHAR_SET,文字名,文字サイズ,フォント,属性,文字名以降くり返し",
"                     属性は'B'が太字で、'I'が斜体です、'BI'が太字で斜体です",
"◎以下は繰り返し指定出来ます。",
"●繰り返し指定    OCCURS,繰り返し数,ｘ,ｙ,繰り返し数以降くり返し",
"                  （ｘ,ｙはオフセット位置です、次のoccurs指定まで有効です）",
"●任意の線を引く   LINE,線名,x1,y1,x2_f,y2[,x1以降くり返し]",
"●長方形の線を引く BOX,線名,x1,y1,x2_f,y2[,x1以降くり返し]",
"●横の線を引く     X_LINE,線名,x1,y,x2_f[,yのくり返し]",
"●縦の線を引く     Y_LINE,線名,x,y1,y2[,xのくり返し]",
"●楕円を引く       ARC,線名,x1,y1,x2_f,y2,開始角度,終了角度[,x1以降のくり返し]",
"●文字を印字       TEXT,文字列,文字名,[文字間隔],x,y,文字数,編集[,文字名以降くり返し]",
"      文字数が０の時は文字列より文字数を計算します)",
"      (編集はRは右詰め,Dは日付け(yyy_fY-MM-DD),-,+,.は数値で','を付加して右詰め、",
"      Zは単に右詰めしますがZと．は少数点以下が０の時は．以下を印字しません",
"      Yは日付けを日月年の順番（DD-MM-yyy_fY)で表示します）",
"●データを印字     DATA,文字名,[文字間隔],x,y,文字数,編集[,文字名以降くり返し]",
"●CODE39を印字 CODE39,[文字列],細線幅,ｺｰﾄﾞ縦,x,y,文字ｻｲｽﾞ,文字x,文字y[,細線幅以降くり返]",
"               (文字ｘと文字ｙはバーコード印字左下位置からのオフセット位置です）",
"               (文字列の最初と最後に'*'が無い場合はデジット文字と*を付加します）",
"               (文字列にバーコード変換不可能文字が有るとエラー終了します）",
"               (文字列が空白の場合データから設定します）",
"●JANを印字する JAN,[文字列],細線幅,ｺｰﾄﾞ縦,x,y[,細線幅以降くり返し]",
"                (８文字か１３文字以外印字出来ません）",
"                (文字はOCR-Bフォントではありません）",
"                (７文字か１２文字の時はデジット文字を付加します）",
" 　             (文字列が空白の場合データから設定します）",
"●VERSIONを判定 VERSION,バージョン番号",
"◎開始は開始頁を指定します、省略又は０の時は１頁目の指定です。",
"◎終了は終了頁を指定します、省略又は０の時は最後の頁の指定です。",
"○用紙の種類は該当プリンタの指定可能なもののみ使用下さい。"};
int bb,ss,dd,i,j,k,l,m,m_max,m_xx,m_yy,jan_pt_no,jan_0,jan_1,jan_2
  ,jan_3,sw_txt=0,control=0,kk,test_data_no=0,start_cnt=1,stop_cnt=0
  ,page_cnt=1,data_max=0,data_cnt=0,sw_data_end=0,char_occurs_start=-1
  ,line_occurs_start=-1,rc,count,max,sw_error=0,sw_fin=0,sw_continue=0
  ,REAL=3,TEST=2,TEST_DATA=1;
float f_f,mm_f,xx_f,yy_f,x1_f,x2_f,y1_f,y2_f,xxx_f,yyy_f,ritu_f=1,xOf_f=0,yOf_f=0,pos_f,nxt_f,short_bar_f
   ,short_bar2_f,short_bar3_f,short_space_f
   ,long_bar_f,long_bar2_f,long_bar3_f,long_space_f;
float[] jan_e_fx=new float[2],jan_b_fx=new float[2];
string doc_s,layout_file_s="IPRINT.CSV",paper_size_s="",paper_hv_s=""
  ,txt_file_s="IPRINT.TXT",read_s,default_font_s="MS Gothic"
  ,code39_mozi="1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%";
string[] data_sx;
int[,] code39_bar_ixx={{0,0,0,0,0}
    ,{1,0,0,0,1},{0,1,0,0,1},{1,1,0,0,0},{0,0,1,0,1},{1,0,1,0,0},
     {0,1,1,0,0},{0,0,0,1,1},{1,0,0,1,0},{0,1,0,1,0},{0,0,1,1,0},{0,0,0,0,0}}
 ,code39_space_ixx={{1,1,1,0,0},{1,1,0,1,0},{1,0,1,1,0},{0,1,1,1,0}
         ,{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{1,0,0,0,0}}
 ,jan_bar={{3,2,1,1},{2,2,2,1},{2,1,2,2},{1,4,1,1},{1,1,3,2},
        {1,2,3,1},{1,1,1,4},{1,3,1,2},{1,2,1,3},{3,1,1,2}}
 ,jan_pt={{1,1,1,1,1,1},{1,1,0,1,0,0},{1,1,0,0,1,0},{1,1,0,0,0,1},
     {1,0,1,1,0,0},{1,0,0,1,1,0},{1,0,0,0,1,1},{1,0,1,0,1,0},{1,0,1,0,0,1},
     {1,0,0,1,0,1}};
Font font_o;Pen pen_o;Brush solid_brush_o;
ArrayList char_name_a=new ArrayList(),char_size_a=new ArrayList()
  ,char_font_a=new ArrayList(),char_kind_a=new ArrayList()
  ,line_name_a=new ArrayList(),line_size_a=new ArrayList()
  ,line_kind_a=new ArrayList(),pen_a=new ArrayList()
  ,offset_a=new ArrayList(),occurs_a=new ArrayList(),s_a=new ArrayList()
  ,in_a=new ArrayList(),out_a=new ArrayList(),char_a=new ArrayList()
  ,line_a=new ArrayList();
z_l z=new z_l();
read_l read_o;
int sw_read=0;
//****( Printer Seting begin )*************************
form_l(string[] arg_sxi,int version_ii)
{read_o=new read_l(z);
Text="IPRINT VERSION="+version_ii;
solid_brush_o=new SolidBrush(Color.Black);
font_o=new Font(default_font_s,4,FontStyle.Regular,GraphicsUnit.Millimeter);
ClientSize=new Size(font_o.Height*35,font_o.Height*35);
BackColor=SystemColors.Window;
char_name_a.Add("");char_size_a.Add((float)3.5);
char_font_a.Add(default_font_s);char_kind_a.Add("");
i=0;
if(arg_sxi.Length>0)
  if     (arg_sxi[0].ToUpper()=="REAL")control=REAL;
  else if(arg_sxi[0].ToUpper()=="TEST")control=TEST;
  else if(arg_sxi[0].ToUpper()=="TEST_DATA")control=TEST_DATA;
if(arg_sxi.Length>1)txt_file_s=arg_sxi[1];
if(arg_sxi.Length>2)layout_file_s=arg_sxi[2];
if(arg_sxi.Length>3)if(!to_int_b(ref start_cnt,arg_sxi[3]))goto err;
if(arg_sxi.Length>4)if(!to_int_b(ref stop_cnt,arg_sxi[4]))goto err;
if(1>start_cnt){z.err_s="start page("+start_cnt+") error";goto err;}
if(0>stop_cnt||0!=stop_cnt&&stop_cnt<start_cnt)
 {z.err_s="stop page("+stop_cnt+") error";goto err;}
if(-1==(i=txt_file_s.LastIndexOf('\\')))i=0;
doc_s=txt_file_s.Substring(i);
ip_context_menu_v();
KeyDown+=new KeyEventHandler(keydown_v);
if(0==control)
 {paper_size_s="A4";paper_hv_s="1";char_a.Clear();
  for(i=0;help_sx.Length>i;i++)
   {out_a=new ArrayList();out_a.Add("TEXT");out_a.Add(help_sx[i]);
    out_a.Add(new ArrayList());out_a.Add("");out_a.Add((float)0);out_a.Add((float)0);
    out_a.Add((float)(i*3.5));out_a.Add((int)0);out_a.Add("");
    char_a.Add(out_a);
   }
   offset_a.Add((float)0);offset_a.Add((float)0);
   return;
  }
if(!read_o.open_b(layout_file_s,"/"))goto err;
layout_loop:
if(0!=sw_read)goto layout_fin;
read_s="";
layout_read:
if(0!=(rc=read_o.read()))if(1==rc)sw_read=1;else goto err;
else if(read_o.data_s.Length>0&&'\\'==read_o.data_s[read_o.data_s.Length-1])
   {read_s+=read_o.data_s.Substring(0,read_o.data_s.Length-1).TrimStart();
    goto layout_read;
   }
  else read_s+=read_o.data_s.TrimStart();
if(""==read_s||read_s.Length>0&&'*'==read_s[0])goto layout_loop;
csv_split_v(ref s_a,read_s);
if(0==s_a.Count)goto layout_loop;
out_a=new ArrayList();count=4;
switch(((string)s_a[0]).ToUpper())
  {
case "DATA":for(;s_a.Count<7||0!=((s_a.Count-1)%6);)s_a.Add("");
            out_a.Add(s_a[0]);out_a.Add("");out_a.Add(new ArrayList());
            data_max++;
            for(i=1;s_a.Count>i;i+=6)
              {if(-1==(j=char_name_a.IndexOf(s_a[i])))
                 {z.err_s="Char name \""+s_a[i]+"\" is not found";goto layout_err;}
               out_a.Add(char_name_a[j]);
               if(!to_float_b(ref f_f,(string)s_a[i+1]))goto layout_err;
               out_a.Add(f_f);
               if(!to_float_b(ref f_f,(string)s_a[i+2]))goto layout_err;
               out_a.Add(f_f);
               if(!to_float_b(ref f_f,(string)s_a[i+3]))goto layout_err;
               out_a.Add(f_f);
               if(!to_int_b(ref j,(string)s_a[i+4]))goto layout_err;
               out_a.Add(j);
               out_a.Add(s_a[i+5]);
              }
            char_a.Add(out_a);
            goto layout_loop;
case "TEXT":for(;s_a.Count<8||0!=((s_a.Count-2)%6);)s_a.Add("");
            out_a.Add(s_a[0]);out_a.Add(s_a[1]);out_a.Add(new ArrayList());
            for(i=2;s_a.Count>i;i+=6)
              {if(-1==(j=char_name_a.IndexOf(s_a[i])))
                 {z.err_s="Char name \""+s_a[i]+"\" is not found";goto layout_err;}
               out_a.Add(char_name_a[j]);
               if(!to_float_b(ref f_f,(string)s_a[i+1]))goto layout_err;
               out_a.Add(f_f);
               if(!to_float_b(ref f_f,(string)s_a[i+2]))goto layout_err; 
               out_a.Add(f_f);
               if(!to_float_b(ref f_f,(string)s_a[i+3]))goto layout_err;
               out_a.Add(f_f);
               if(!to_int_b(ref j,(string)s_a[i+4]))goto layout_err;
               out_a.Add(j);
               out_a.Add(s_a[i+5]);
              }
            char_a.Add(out_a);
            goto layout_loop;
case "CODE39":for(;s_a.Count<9;)s_a.Add("");
              out_a.Add(s_a[0]);out_a.Add(s_a[1]);out_a.Add(new ArrayList());
              if(""==(string)s_a[1])data_max++;
              if(!to_float_b(out_a,2,7))goto layout_err;
              char_a.Add(out_a);
              goto layout_loop;
case "JAN":for(;s_a.Count<6;)s_a.Add("");
           out_a.Add(s_a[0]);out_a.Add(s_a[1]);out_a.Add(new ArrayList());
           if(""==(string)s_a[1])data_max++;
           if(!to_float_b(out_a,2,4))goto layout_err;
           char_a.Add(out_a);
           goto layout_loop;
case "X_LINE":count=3;goto case "BOX";
case "Y_LINE":count=3;goto case "BOX";
case "LINE":count=4;goto case "BOX";
case "ARC":count=6;goto case "BOX";
case "BOX":for(;s_a.Count<(2+count);)s_a.Add("");
           out_a.Add(s_a[0]);
           if(-1==(j=line_name_a.IndexOf(s_a[1])))
             {z.err_s="Line name \""+s_a[1]+"\" is not found";goto layout_err;}
           out_a.Add(line_name_a[j]);
           if(!to_float_b(out_a,2,0))goto layout_err;
           line_a.Add(out_a);
           goto layout_loop;
case "OCCURS":occurs();
              line_occurs_start=line_a.Count;
              char_occurs_start=char_a.Count;
              for(i=1;s_a.Count>j;j+=3)
                {if(!to_int_b(ref j,(string)s_a[i]))goto layout_err;
                 occurs_a.Add(j);
                 if(!to_float_b(ref f_f,(string)s_a[i+1]))goto layout_err;
                 occurs_a.Add(f_f);
                 if(!to_float_b(ref f_f,(string)s_a[i+2]))goto layout_err;
                 occurs_a.Add(f_f);
                }
              goto layout_loop;
 case "LINE_SET":for(;0!=(s_a.Count-1)%3;)s_a.Add("");
                 for(i=1;s_a.Count>i;i+=3)
                   {line_name_a.Add(s_a[i]);
                    if(!to_float_b(ref f_f,(string)s_a[i+1]))goto layout_err;
                    line_size_a.Add(zero_float_f(f_f));
                    line_kind_a.Add(s_a[i+2]);
                   }
                goto layout_loop;
case "CHAR_SET":for(;0!=(s_a.Count-1)%4;)s_a.Add("");
                for(i=1;s_a.Count>i;i+=4)
                  {char_name_a.Add(s_a[i]);
                   if(!to_float_b(ref f_f,(string)s_a[i+1]))goto layout_err;
                   char_size_a.Add(zero_float_f(f_f));
                   char_font_a.Add(s_a[i+2]);
                   char_kind_a.Add(s_a[i+3]);
                  }
                goto layout_loop;
case "OFFSET":if(!to_float_b(offset_a,1,2))goto layout_err;
              goto layout_loop;
case "PAPER":if(2!=s_a.Count&&3!=s_a.Count)goto layout_err_count;
             paper_size_s=(string)s_a[1];
             if(3==s_a.Count)paper_hv_s=(string)s_a[2];
             goto layout_loop;
case "VERSION":if(2!=s_a.Count)goto layout_err_count;
               if(!to_int_b(ref j,(string)s_a[1]))goto layout_err;
               if(version_ii<j){z.err_s="version "+version_ii+" < "+j+" No good";goto err;}
               goto layout_loop;
default:break;
  }
goto layout_err;
layout_fin:
occurs();
if(0==offset_a.Count){offset_a.Add((float)0);offset_a.Add((float)0);}
data_max*=offset_a.Count/2;
read_o.close_v();
if(TEST_DATA==control)return;
if(!read_o.open_b(txt_file_s,"/"))goto err;
//================( print start )=========================
data_read0:
i=0;
data_read:
if(!read_b())goto err;
if(1==sw_data_end){z.err_s="Start Page Over";goto err;}
if(page_cnt<start_cnt)
 {i+=data_sx.Length;
  if(data_max>i)goto data_read;
  if(data_max<i){z.err_s="Page End data Count Error";goto err;}
  page_cnt++;
  goto data_read0;
 }
return;
//***************************************************************************
layout_err_count:
z.err_s="Count("+s_a.Count+")";
layout_err:
err:
if(0==sw_error)sw_error=1;
return;
}
//=====( occurs )=====
void occurs()
{if(occurs_a.Count>0)
  {max=line_a.Count;
   for(xx_f=yy_f=i=0;i<occurs_a.Count;i+=3)
   for(j=0;(int)occurs_a[i]>j;j++)
    {xx_f+=(float)occurs_a[i+1];yy_f+=(float)occurs_a[i+2];
     for(k=line_occurs_start;k<max;k++)
      {in_a=(ArrayList)line_a[k];out_a=new ArrayList();l=0;
       out_a.Add(in_a[l++]);out_a.Add(in_a[l++]);
       line_loop:
       out_a.Add((float)in_a[l++]+xx_f);out_a.Add((float)in_a[l++]+yy_f);
       if("Y_LINE"==(string)in_a[0])out_a.Add((float)in_a[l++]+yy_f);
       else
        {out_a.Add((float)in_a[l++]+xx_f);
         if(z.equal_b((string)in_a[0],"BOX","LINE","ARC"))
          {out_a.Add((float)in_a[l++]+yy_f);
          if("ARC"==(string)in_a[0])
             {out_a.Add((float)in_a[l++]);out_a.Add((float)in_a[l++]);}
           if(in_a.Count>(l+1))goto line_loop;
           line_a.Add(out_a);
           continue;
          }
        }
       if("Y_LINE"==(string)in_a[0])mm_f=xx_f;else mm_f=yy_f;
       for(;in_a.Count>l;l++)out_a.Add((float)in_a[l++]+mm_f);
       line_a.Add(out_a);
      }
    }
   max=char_a.Count;
   for(xx_f=yy_f=0,i=0;occurs_a.Count>i;i+=3)
   for(j=0;(int)occurs_a[i]>j;j++)
    {xx_f+=(float)occurs_a[i+1];yy_f+=(float)occurs_a[i+2];
     for(k=char_occurs_start;k<max;k++)
      {in_a=(ArrayList)char_a[k];out_a=new ArrayList();
       out_a.Add(in_a[0]);out_a.Add(in_a[1]);out_a.Add(in_a[2]);
       if(""==(string)in_a[1])data_max++;
       m_max=(""==(string)in_a[0]?5:"CODE39"==(string)in_a[0]?7:4);
       m_xx=(""==(string)in_a[0]?1:2);
       m_yy=(""==(string)in_a[0]?2:3);
       for(l=3;l<in_a.Count;)
       for(m=0;m_max>m;m++)
         if     (m_xx==m)out_a.Add((float)in_a[l++]+xx_f);
         else if(m_yy==m)out_a.Add((float)in_a[l++]+yy_f);
         else out_a.Add(in_a[l++]);
       char_a.Add(out_a);
      }
    }
  }
occurs_a.Clear();
}
//=====( bool read )=====
bool read_b()
{int rc;
 if(0==sw_data_end)
  if(0!=(rc=read_o.read()))
    if(1==rc)sw_data_end=1;else return false;
    else data_sx=read_o.data_s.Split('\t');
data_cnt=0;
return true;
}
bool printer_b()
{int sw=0;
Console.WriteLine("printer");
try{PrintDocument pd_o=new PrintDocument(); 
    pd_o.PrintPage+=new PrintPageEventHandler(print_v);
    pd_o.DocumentName=doc_s;
    if(""!=paper_size_s)
     {foreach(PaperSize paper_size in pd_o.PrinterSettings.PaperSizes)
        if(0==string.Compare(paper_size_s,paper_size.PaperName,true))
          {pd_o.DefaultPageSettings.PaperSize=paper_size;sw=1;break;}
      if(0==sw){z.err_s="PaperSize \""+paper_size_s+"\" is not found";return false;}
     } 
    if     ("1"==paper_hv_s)pd_o.DefaultPageSettings.Landscape=false;
    else if("2"==paper_hv_s)pd_o.DefaultPageSettings.Landscape=true;
    pd_o.Print();
   }
catch(Exception e){z.err_s=e.Message;return false;}
if(0!=sw_error)return false;
return true;
}
//=====( print )=====
void print_v(object o_ni, PrintPageEventArgs e_ni)
{if(0!=data_cnt){z.err_s="Page End data Count("+data_max+") Error";goto err;}
if(!print_b(e_ni.Graphics,0,0,1,sw_txt))goto err;
if(REAL!=control){sw_txt=1;goto fin;}
page_cnt++;
if(0!=stop_cnt&&page_cnt>stop_cnt||0==data_max)sw_data_end=1;
if(0!=sw_data_end)goto fin;else e_ni.HasMorePages=true;
return;
err:sw_error=1;
e_ni.Cancel=true;
fin:
e_ni.HasMorePages=false;
return;
}
bool print_b(Graphics Graphics_ni,float xx_fi,float yy_fi,float ritu_fi,int sw_ii)
{int i;
Graphics_ni.PageUnit=GraphicsUnit.Millimeter;
for(i=0;offset_a.Count>i;i+=2)
 {if(!print_sub_b(Graphics_ni,i/2,xx_fi+(float)offset_a[i],yy_fi+(float)offset_a[i+1]
  ,ritu_fi,sw_ii))return false;
 if(1==sw_data_end)return true;
 }
return true;
}
//=====( print_sub )=====
bool print_sub_b(Graphics Graphics_ni,int i_ii,float xx_fi,float yy_fi,float ritu_fi,int sw_ii)
{int i,j,k;string s;float f_f;
foreach(ArrayList a in line_a)  //線印刷
 {out_a=(ArrayList)a;
  k=line_name_a.IndexOf((string)out_a[1]);
  f_f=(float)line_size_a[k]*ritu_fi;
  if(0==f_f)f_f=0.1f;
  pen_o=new Pen(solid_brush_o,f_f);
  if     ("1"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.Dash;
  else if("2"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.Dot;
  else if("3"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.DashDot;
  else if("4"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.DashDotDot;
  if("X_LINE"==(string)out_a[0])
   {x1_f=(xx_fi+(float)out_a[2])*ritu_fi;
    y1_f=(yy_fi+(float)out_a[3])*ritu_fi;
    x2_f=(xx_fi+(float)out_a[4])*ritu_fi;Graphics_ni.DrawLine(pen_o,x1_f,y1_f,x2_f,y1_f);
    for(i=5;out_a.Count>i;i++)
      {y1_f=(yy_fi+(float)out_a[i])*ritu_fi;Graphics_ni.DrawLine(pen_o,x1_f,y1_f,x2_f,y1_f);}
   }
  else if("Y_LINE"==(string)out_a[0])
     {x1_f=(xx_fi+(float)out_a[2])*ritu_fi;
      y1_f=(yy_fi+(float)out_a[3])*ritu_fi;
      y2_f=(yy_fi+(float)out_a[4])*ritu_fi;Graphics_ni.DrawLine(pen_o,x1_f,y1_f,x1_f,y2_f);
      for(i=5;out_a.Count>i;i++)
       {x1_f=(xx_fi+(float)out_a[i])*ritu_fi;Graphics_ni.DrawLine(pen_o,x1_f,y1_f,x1_f,y2_f);}
     }
  else if("ARC"==(string)out_a[0])
    for(i=2;out_a.Count>i;i+=6)
     {x1_f=(xx_fi+(float)out_a[i])*ritu_fi;
      y1_f=(yy_fi+(float)out_a[i+1])*ritu_fi;
      x2_f=(xx_fi+(float)out_a[i+2])*ritu_fi;
      y2_f=(yy_fi+(float)out_a[i+3])*ritu_fi;
      Graphics_ni.DrawArc(pen_o,(x1_f<x2_f?x1_f:x2_f),(y1_f<y2_f?y1_f:y2_f)
       ,(x1_f>x2_f?x1_f-x2_f:x2_f-x1_f),(y1_f>y2_f?y1_f-y2_f:y2_f-y1_f)
       ,((float)out_a[i+4]),((float)out_a[i+5]));
     }
 else  for(i=2;out_a.Count>i;i+=4)
     {x1_f=(xx_fi+(float)out_a[i])*ritu_fi;
      y1_f=(yy_fi+(float)out_a[i+1])*ritu_fi;
      x2_f=(xx_fi+(float)out_a[i+2])*ritu_fi;
      y2_f=(yy_fi+(float)out_a[i+3])*ritu_fi;
      if("BOX"==(string)out_a[0])
       Graphics_ni.DrawRectangle(pen_o,(x1_f<x2_f?x1_f:x2_f),(y1_f<y2_f?y1_f:y2_f)
       ,(x1_f>x2_f?x1_f-x2_f:x2_f-x1_f),(y1_f>y2_f?y1_f-y2_f:y2_f-y1_f));
      else Graphics_ni.DrawLine(pen_o,x1_f,y1_f,x2_f,y2_f);
     }
 }
foreach(ArrayList a in char_a) //文字印刷
 {out_a=a;
  if(""!=(string)out_a[1])s=(string)out_a[1];
  else if(0!=sw_ii)s=(string)((ArrayList)out_a[2])[i_ii];
  else
   {if(TEST_DATA==control)
     {if(10==++test_data_no)test_data_no=0;s=""+test_data_no;}
    else 
      if(0==sw_data_end)
       {s=data_sx[data_cnt];if(data_sx.Length<=++data_cnt)read_b();}
      else s="";
    ((ArrayList)out_a[2]).Add(s);
   }
  String keep_s=s;
  for(i=3;out_a.Count>i;)
   {s=keep_s;
    if(z.equal_b((string)out_a[0],"TEXT","DATA"))
     {if(z.equal_b((string)out_a[i+5],"+","-",".")&&0<(int)out_a[i+4])
       {if(TEST_DATA==control)
          s=s.PadRight((int)out_a[i+4]-(int)out_a[i+4]/4,s[0]);
        s=z.comma_s(s);
        s=s.PadLeft((int)out_a[i+4]);
      }
      else if(z.equal_b((string)out_a[i+5],"R","Z")) //right
       {if(0!=(int)out_a[i+4])s=s.PadLeft((int)out_a[i+4]);}
      else if("D"==(string)out_a[i+5])
       {if(TEST_DATA==control)s=s.PadRight(8,s[0]);
        if(s.Length==8)s=""+s[0]+s[1]+s[2]+s[3]+"-"+s[4]+s[5]+"-"+s[6]+s[7];
       }
      else if("Y"==(string)out_a[i+5])
       {if(TEST_DATA==control)s=s.PadRight(8,s[0]);
        if(s.Length==8)s=""+s[6]+s[7]+"-"+s[4]+s[5]+"-"+s[0]+s[1]+s[2]+s[3];
       }
      else if(TEST_DATA==control)s=s.PadRight((int)out_a[i+4],s[0]);
      if(z.equal_b((string)out_a[i+5],".","Z")) //.00 空白変換
        for(j=s.Length-1;0<j;j--)
          if('0'==s[j])continue;else if('.'==s[j])s=s.Substring(0,j);else break;
     //version1// k=char_name_a.IndexOf(out_a[3]);
      k=char_name_a.IndexOf(out_a[i]); // version2
      font_o=new Font((string)char_font_a[k],(float)char_size_a[k]*ritu_fi
          ,(-1!=((string)char_kind_a[k]).ToLower().IndexOf('b')
           ?FontStyle.Bold:FontStyle.Regular)
           |(-1!=((string)char_kind_a[k]).ToLower().IndexOf('i')
           ?FontStyle.Italic:FontStyle.Regular),GraphicsUnit.Millimeter);
      if(0<(int)out_a[i+4])s=s.PadRight((int)out_a[i+4]);
      z.draw_string_v(Graphics_ni,(float)out_a[i+1],s,font_o,Brushes.Black
      ,(xx_fi+(float)out_a[i+2])*ritu_fi,(yy_fi+(float)out_a[i+3])*ritu_fi);
      i+=6;
     }
    else if("CODE39"==(string)out_a[0])
       {if(!code39_b(Graphics_ni,xx_fi,yy_fi,ritu_fi,s,i))return false;i+=7;}
    else if("JAN"==(string)out_a[0])
       {if(!jan_b(Graphics_ni,xx_fi,yy_fi,ritu_fi,s,i))return false;i+=4;}
   }
 }
return true;
}
//=====( keydown )=====
void keydown_v(object o_ni,KeyEventArgs e_ni)
{if(REAL==control)return;
switch(e_ni.KeyCode)
  {
case Keys.Home: ritu_f=1;xx_f=yOf_f=0;break;
case Keys.End:  ritu_f=1;break;
case Keys.Enter:sw_txt=0;
                if(1==sw_data_end)
                  {sw_data_end=0;read_o.close_v();
                   if(!read_o.open_b(txt_file_s,"/"))sw_error=1;
                   if(!read_b())sw_error=1;
                  }
                break;
case Keys.Up:   if(0>yOf_f)yOf_f+=(10/ritu_f);break;
case Keys.Down: yOf_f-=(10/ritu_f);break;
case Keys.Left: if(0>xOf_f)xOf_f+=(10/ritu_f);break;
case Keys.Right:xOf_f-=(10/ritu_f);break;
case Keys.Insert:ritu_f+=(float)0.1;break;
case Keys.Delete:if(ritu_f>0.2)ritu_f-=(float)0.1;break;
case Keys.Escape:Close();return;
default:return;
  }
Refresh();
}
protected override void OnPaint(PaintEventArgs e_ni)
{loop:
if(1==sw_continue)return;
if(1==sw_error){sw_error=2;err_v();sw_fin=1;}
if(1==sw_fin){read_o.close_v();Close();return;}
sw_continue=1;
if(0==sw_error&&0==sw_fin)
  if(REAL==control)
    {if(!printer_b())sw_error=1;else sw_fin=1;sw_continue=0;goto loop;}
  else if(!print_b(e_ni.Graphics,xOf_f,yOf_f,ritu_f,sw_txt)){sw_error=1;sw_continue=0;goto loop;}
sw_txt=1;
sw_continue=0;
}
void err_v()
{z.beep_v();
MessageBox.Show(z.err_s+Environment.NewLine+read_s,"IPRINT"
,MessageBoxButtons.OK);
}
void menu1_v(Object o_ni,EventArgs e_ni){if(REAL!=control)if(!printer_b())err_v();}
//=====( Context Mneu )=====
void ip_context_menu_v()
{ContextMenu m0=new ContextMenu();MenuItem m1=new MenuItem();
m1.Text="Print";m1.Click+=new EventHandler(menu1_v);
m0.MenuItems.Add(m1);ContextMenu=m0;
}
//*******************( code39 )********************************
bool code39_b(Graphics Graphics_ni,float xx_fi,float yy_fi,float ritu_fi,string s_si,int i_ii)
{int divi,rem;
//if(TEST_DATA==control)s_si=s_si.PadRight(7,s_si[0]);
if(s_si.Length>0&&('*'!=s_si[0]||'*'!=s_si[s_si.Length-1]))
   s_si="*"+s_si+z.code39_s(s_si)+"*";
short_space_f=short_bar_f=zero_float_f((float)out_a[i_ii])*ritu_fi;
short_bar2_f=short_bar_f/2;
short_bar3_f=short_bar_f-short_bar2_f;
long_space_f=long_bar_f=short_space_f*(float)2.5f;
long_bar2_f=long_bar_f/2;
long_bar3_f=long_bar_f-long_bar2_f;
pen_a.Clear();
pen_a.Add(new Pen(solid_brush_o,short_bar_f));
pen_a.Add(new Pen(solid_brush_o,long_bar_f));
x1_f=((float)out_a[i_ii+2]+xx_fi)*ritu_fi;
y1_f=((float)out_a[i_ii+3]+yy_fi)*ritu_fi;
y2_f=((float)out_a[i_ii+3]+zero_float_f((float)out_a[i_ii+1])+yy_fi)*ritu_fi;
pos_f=0;
foreach(char c in s_si)
 {for(kk=0;code39_mozi.Length>kk&&c!=code39_mozi[kk];)kk++;
  if(code39_mozi.Length<=kk)
   {z.err_s="code39 convert error ("+c+")";return false;}
  divi=kk/10;rem=kk%10;
  if(4==divi){bb=0;ss=rem;}else{bb=rem+1;ss=divi+4;}
  for(kk=0;kk<5;kk++)
   {if(0==code39_bar_ixx[bb,kk]){x1_f+=pos_f+short_bar2_f;nxt_f=short_bar3_f;i=0;}
    else                        {x1_f+=pos_f+long_bar2_f;nxt_f=long_bar3_f;i=1;}
    Graphics_ni.DrawLine((Pen)pen_a[i],x1_f,y1_f,x1_f,y2_f);
    if(0==code39_space_ixx[ss,kk])pos_f=short_space_f+nxt_f;else pos_f=long_space_f+nxt_f;
   }
 }
if(0==(float)out_a[i_ii+4])return true;
x1_f=((float)out_a[i_ii+2]+(float)out_a[i_ii+5]+xx_fi)*ritu_fi;
y1_f=((float)out_a[i_ii+1]+(float)out_a[i_ii+3]+(float)out_a[i_ii+6]+yy_fi)*ritu_fi;
font_o=new Font(default_font_s,(float)out_a[i_ii+4]*ritu_fi
  ,FontStyle.Regular,GraphicsUnit.Millimeter);
z.draw_string_v(Graphics_ni,(float)0,s_si,font_o,Brushes.Black,x1_f,y1_f);
return true;
}
//*******************( jan )********************************
bool jan_b(Graphics Graphics_ni,float xx_fi,float yy_fi,float ritu_fi,string s_si,int i_ii)
{if(TEST_DATA==control)s_si=s_si.PadRight(7,s_si[0]);
if(z.equal_b(s_si.Length,12,7))s_si+=z.jan_s(s_si);
if(13!=s_si.Length&&8!=s_si.Length)
  {z.err_s="jan length 8 or 13 error ("+s_si+")";return false;}
short_bar_f=((float)out_a[i_ii]*ritu_fi);
pen_a.Clear();pen_a.Add(0);
pen_a.Add(new Pen(solid_brush_o,short_bar_f));
pen_a.Add(new Pen(solid_brush_o,short_bar_f*2));
pen_a.Add(new Pen(solid_brush_o,short_bar_f*3));
pen_a.Add(new Pen(solid_brush_o,short_bar_f*4));
x1_f=((float)out_a[i_ii+2]+xx_fi)*ritu_fi;
y1_f=((float)out_a[i_ii+3]+yy_fi)*ritu_fi;
dd=jan_pt_no=0;
jan_loop:
if(0==dd||7==dd&&13==s_si.Length||4==dd&&8==s_si.Length||s_si.Length==dd)
  {y2_f=((float)out_a[i_ii+3]+(float)out_a[i_ii+1]+yy_fi)*ritu_fi;
   if(s_si.Length==dd)jan_e_fx[1]=x1_f;
   if(7==dd&&13==s_si.Length||4==dd&&8==s_si.Length){x1_f+=short_bar_f;jan_e_fx[0]=x1_f;}
   x1_f+=short_bar_f/2;
   Graphics_ni.DrawLine((Pen)pen_a[1],x1_f,y1_f,x1_f,y2_f);
   x1_f+=short_bar_f*2;
   Graphics_ni.DrawLine((Pen)pen_a[1],x1_f,y1_f,x1_f,y2_f);
   x1_f+=short_bar_f-short_bar_f/2;
   if(7==dd&&13==s_si.Length||4==dd&&8==s_si.Length){jan_b_fx[1]=x1_f;x1_f+=short_bar_f;}
  }
if(s_si.Length==dd)goto jan_char;
y2_f=((float)out_a[i_ii+3]+zero_float_f((float)out_a[i_ii+1])
     -(float)out_a[i_ii]*7.5f+yy_fi)*ritu_fi;
if(1==dd&&13==s_si.Length||0==dd)jan_b_fx[0]=x1_f;
if('0'>s_si[dd]||'9'<s_si[dd])
  {z.err_s="jan convert error txt ("+s_si[dd]+")";return false;}
i=Convert.ToInt32(s_si.Substring(dd,1));
if(0==dd&&13==s_si.Length){jan_pt_no=i;goto jan_jump;}
if(7>dd&&13==s_si.Length||4>dd&&8==s_si.Length)
 {j=dd;if(13==s_si.Length)j--;
  if(1==jan_pt[jan_pt_no,j]){jan_0=0;jan_1=1;jan_2=2;jan_3=3;}
  else                      {jan_0=3;jan_1=2;jan_2=1;jan_3=0;}
  x1_f+=short_bar_f*jan_bar[i,jan_0]+short_bar_f*jan_bar[i,jan_1]/2;
  Graphics_ni.DrawLine((Pen)pen_a[jan_bar[i,jan_1]],x1_f,y1_f,x1_f,y2_f);
  x1_f+=short_bar_f*jan_bar[i,jan_1]-short_bar_f*jan_bar[i,jan_1]/2
     +short_bar_f*jan_bar[i,jan_2]+short_bar_f*jan_bar[i,jan_3]/2;
  Graphics_ni.DrawLine((Pen)pen_a[jan_bar[i,jan_3]],x1_f,y1_f,x1_f,y2_f);
  x1_f+=short_bar_f*jan_bar[i,jan_3]-short_bar_f*jan_bar[i,jan_3]/2;
 }
else
 {x1_f+=short_bar_f*jan_bar[i,0]/2;
  Graphics_ni.DrawLine((Pen)pen_a[jan_bar[i,0]],x1_f,y1_f,x1_f,y2_f);
  x1_f+=short_bar_f*jan_bar[i,0]-short_bar_f*jan_bar[i,0]/2
     +short_bar_f*jan_bar[i,1]+short_bar_f*jan_bar[i,2]/2;
  Graphics_ni.DrawLine((Pen)pen_a[jan_bar[i,2]],x1_f,y1_f,x1_f,y2_f);
  x1_f+=short_bar_f*jan_bar[i,2]-short_bar_f*jan_bar[i,2]/2
          +short_bar_f*jan_bar[i,3];
 }
jan_jump:
dd++;
goto jan_loop;
jan_char:
if(8==s_si.Length){jan_0=0;jan_1=4;}else{jan_0=1;jan_1=6;}
xxx_f=(jan_e_fx[0]-jan_b_fx[0])/jan_1;yyy_f=xxx_f*2;
if(0>=xxx_f)xxx_f=0.1f;
if(0>=yyy_f)yyy_f=0.1f;
font_o=new Font(default_font_s,yyy_f-yyy_f*0.025f,FontStyle.Regular
  ,GraphicsUnit.Millimeter);
y1_f=((float)out_a[i_ii+3]+zero_float_f((float)out_a[i_ii+1])+yy_fi)*ritu_fi-xxx_f;
if(8==s_si.Length)goto jan_8;
x1_f=((float)out_a[i_ii+2]+xx_fi)*ritu_fi-xxx_f*1.25f;
z.draw_string_v(Graphics_ni,(float)0,s_si.Substring(0,1),font_o,Brushes.Black,x1_f,y1_f);
jan_8:
for(i=0;2>i;i++)
 {x1_f=jan_b_fx[i]-xxx_f*0.25f;
  z.draw_string_v(Graphics_ni,(float)0,s_si.Substring(jan_0+jan_1*i,jan_1),font_o,Brushes.Black,x1_f,y1_f);
 }
return true;
}
 //=====( csv_split )=====
void csv_split_v(ref ArrayList a_ar,string s_si)
{int i,sta,sw=0;string out_s;a_ar.Clear();
for(sta=i=0;;i++)
 {if(s_si.Length<=i||','==s_si[i]&&0==sw)
   {out_s=s_si.Substring(sta,i-sta).Trim();
    if(1<out_s.Length&&'"'==out_s[0]&&'"'==out_s[out_s.Length-1])
      out_s=out_s.Substring(1,out_s.Length-2);
    out_s=out_s.Replace("\"\"","\"");
    a_ar.Add(out_s);
    if(s_si.Length<=i)break;
    sta=i+1;
    if(s_si.Length<=sta){a_ar.Add("");break;}
    continue;
   }
  if('"'==s_si[i])if(0==sw)sw=1;else sw=0;
 }
}
bool to_float_b(ArrayList a_ar,int i_ii,int count_ii)
{float f=0;
if(0!=count_ii&&0!=(s_a.Count-i_ii)%count_ii)
 {z.err_s="Count("+s_a.Count+")";return false;}
for(i=i_ii;s_a.Count>i;i++)
 {if(!to_float_b(ref f,(string)s_a[i]))return false;a_ar.Add(f);}
return true;
}
bool to_float_b(ref float f_fr,string s_si)
{if(""==s_si){f_fr=0;return true;}
try{f_fr=(float)Convert.ToDouble(s_si);}
catch(Exception e_ni){z.err_s="("+s_si+")"+e_ni.Message;return false;}
return true;
}
bool to_int_b(ref int i_ir,string s_si)
{if(""==s_si){i_ir=0;return true;}
try{i_ir=Convert.ToInt32(s_si);}
catch(Exception e_ni){z.err_s="("+s_si+")"+e_ni.Message;return false;}
return true;
}
float zero_float_f(float f_fi){return (0>=f_fi?0.1f:f_fi);}
protected override void OnClosed(EventArgs e){}
static void Main(string[] arg_sxi)
{
//==========( バージョンアップ時変更の事 )==================================================
//*** 注意：SET_END.TXTの
//***     　=  VALUES('ZZZZ_@','ZZZZ_VERSION','2','VERSION(2) IPRINT')}
//***    　の２箇所の'2'の部分を最新バージョンに修正する事。
int version=2;
//==========================================================================================
if(2!=arg_sxi.Length||"VERSION"!=arg_sxi[0].ToUpper()||"VERSION"!=arg_sxi[1].ToUpper())goto run;
//バージョンをVERSION_IPRINT.TXTファイルに出力******************
#if UNIX
string file_s="/home/I/TMP/"
#else
string file_s="\\I\\TMP\\"
#endif
   +"VERSION_IPRINT.TXT";

try{FileStream FileStream_n=File.Open(file_s,FileMode.Create,FileAccess.Write,FileShare.Read);
    StreamWriter stream_writer_o=new StreamWriter(FileStream_n);
    stream_writer_o.WriteLine(""+version); 
    stream_writer_o.Close();
   }
catch(Exception){}
goto fin;
run:Application.Run(new form_l(arg_sxi,version));
fin:;
}
}
